Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunctionTreeView.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunctionTreeView.cs	(revision 2215)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/FunctionTreeView.cs	(revision 2216)
@@ -67,6 +67,6 @@
       treeNodeContextMenu.MenuItems.Add(representationsMenu);
       DiscoveryService discoveryService = new DiscoveryService();
-      IFunctionTreeExporter[] exporters = discoveryService.GetInstances<IFunctionTreeExporter>();
-      foreach (IFunctionTreeExporter exporter in exporters) {
+      IFunctionTreeSerializer[] exporters = discoveryService.GetInstances<IFunctionTreeSerializer>();
+      foreach (IFunctionTreeSerializer exporter in exporters) {
         string result;
         // register a menu item for the exporter
@@ -101,5 +101,5 @@
     }
 
-    private EventHandler MakeExporterDelegate(IFunctionTreeExporter exporter) {
+    private EventHandler MakeExporterDelegate(IFunctionTreeSerializer exporter) {
       return delegate(object source, EventArgs args) {
         TreeNode node = funTreeView.SelectedNode;
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/GeneralTreeSerializer.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/GeneralTreeSerializer.cs	(revision 2216)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/GeneralTreeSerializer.cs	(revision 2216)
@@ -0,0 +1,71 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Core;
+using System.Linq;
+using System.Collections;
+using HeuristicLab.GP.Interfaces;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.GP {
+  public static class GeneralTreeSerializer {
+    private static IFunctionTreeSerializer serializer;
+
+    internal static string Export(IFunctionTree functionTree) {
+      if (serializer != null || FindSerializer(functionTree)) {
+        return serializer.Export(functionTree);
+      } else throw new NotSupportedException("Can't serialize function trees. A matching export couldn't be found");
+    }
+
+    internal static IFunctionTree Import(string p) {
+      if (serializer != null || FindSerializer(p)) {
+        return serializer.Import(p);
+      } else throw new NotSupportedException("Can't serialize function trees. A matching export couldn't be found");
+    }
+
+    private static bool FindSerializer(IFunctionTree functionTree) {
+      DiscoveryService discoveryService = new DiscoveryService();
+      string exported;
+
+      foreach (IFunctionTreeSerializer exporter in discoveryService.GetInstances<IFunctionTreeSerializer>()) {
+        if (exporter.TryExport(functionTree, out exported)) {
+          GeneralTreeSerializer.serializer = exporter;
+          return true;
+        }
+      }
+      return false;
+    }
+    private static bool FindSerializer(string functionTree) {
+      DiscoveryService discoveryService = new DiscoveryService();
+      IFunctionTree exported;
+
+      foreach (IFunctionTreeSerializer importer in discoveryService.GetInstances<IFunctionTreeSerializer>()) {
+        if (importer.TryImport(functionTree, out exported)) {
+          GeneralTreeSerializer.serializer = importer;
+          return true;
+        }
+      }
+      return false;
+    }
+  }
+}
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/GeneticProgrammingModel.cs
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/GeneticProgrammingModel.cs	(revision 2215)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/GeneticProgrammingModel.cs	(revision 2216)
@@ -25,4 +25,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.GP.Interfaces;
+using System.Xml;
 
 namespace HeuristicLab.GP {
@@ -56,10 +57,13 @@
     }
 
-    public override System.Xml.XmlNode GetXmlNode(string name, System.Xml.XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
-      throw new NotImplementedException();
+    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+      node.Value = GeneralTreeSerializer.Export(FunctionTree);
+      return node;
     }
 
-    public override void Populate(System.Xml.XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
-      throw new NotImplementedException();
+    public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+      base.Populate(node, restoredObjects);
+      FunctionTree = GeneralTreeSerializer.Import(node.Value);
     }
 
Index: branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/HeuristicLab.GP-3.3.csproj
===================================================================
--- branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/HeuristicLab.GP-3.3.csproj	(revision 2215)
+++ branches/GP-Refactoring-713/sources/HeuristicLab.GP/3.3/HeuristicLab.GP-3.3.csproj	(revision 2216)
@@ -83,8 +83,11 @@
   <ItemGroup>
     <Compile Include="BaseClasses\BinaryFunction.cs" />
+    <Compile Include="BaseClasses\FunctionLibraryInjectorBase.cs" />
+    <Compile Include="BaseClasses\TerminalTreeNode.cs" />
     <Compile Include="BaseClasses\FunctionBase.cs" />
     <Compile Include="BaseClasses\FunctionTreeBase.cs" />
     <Compile Include="BaseClasses\Terminal.cs" />
     <Compile Include="BaseClasses\UnaryFunction.cs" />
+    <Compile Include="FunctionTreeSerializer.cs" />
     <Compile Include="FunctionLibrary.cs" />
     <Compile Include="FunctionLibraryEditor.cs">
